# Op Layout

The first three bits are the category, the next four are the op, the last one is whether or not the op should operate on two bytes (1 for 2byte/16bit, 0 for 1byte/8bit)

```
[ 000  0000  0 ]
   |    \/   |
  Cat   Op 2byte
```

1. memory - 000
  1. set - 000
  2. get - 001
  3. sei - 010 - set indirect (use a pointer stores elswhere)
  4. gei - 011
  5. .
  6. .
  7. .
2. stack  - 001
  1. psh - 000
  2. pop - 001
  3. ovr - 010
  4. swp - 011
  5. rot - 100
  6. dup - 101
  7. .
3. math   - 010
  1. add - 000
  2. sub - 001
  3. mul - 010
  4. div - 011
  5. inc - 100
  6. dec - 101
  7. .
4. bits   - 011
  1. and - 000
  2. bor - 001 (bitwise or)
  3. xor - 010
  4. not - 011
  5. shr - 100
  6. shl - 101
  7. eql - 111
5. jump   - 100
  1. jmp - 000
  2. sub - 001
  3. jcd - 010
  4. ret - 011
  5. .
  6. .
  7. .
7. sys    - 101
  1. gch - 000
  2. gst - 001
  3. pch - 010
  4. pst - 011
  5. hlt - 100
  6. .
  7. .
  8. .
  9. .
 10. .
 11. .
 12. .
 13. .
 14. .
 15. .
 16. .
 17. .
 18. .
 19. .
 20. .
 21. .
 22. .
 23. .
 24. .
 25. .
 26. .
 27. .
 28. .
8. dev    - 111
  1. .
  2. .
  3. .
  4. .
  5. .
  6. .
  7. .
  8. .
  9. .
 10. .
 11. .
 12. .
 13. .
 14. .
 15. .
 16. .
 17. .
 18. .
 19. .
 20. .
 21. .
 22. .
 23. .
 24. .
 25. .
 26. .
 27. .
 28. .

## Memory Layout

```
var memory = [MAX_uint16]byte{}
```

## Stack
